// Dialog.h: _CAO֌WNX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIALOG_H__B58B4FBD_56DB_4DEF_BF29_A19185CDB778__INCLUDED_)
#define AFX_DIALOG_H__B58B4FBD_56DB_4DEF_BF29_A19185CDB778__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../../UI/Common/ExtractMode.h"
#include "../../Archive/IArchive.h"
#include "Common/StringConvert.h"
#include "Common/MyCom.h"
#include "7-zip32.h"

extern HINSTANCE g_hInstance;
extern BOOL g_bIsNT;

BOOL CALLBACK GetProcessLastActivePopup(HWND hWnd, LPARAM lParam);

class CDialog  
{
public:
	int GetDlgItemTextW(int nID, UString& rString);
	BOOL SetDlgItemTextW(int nID, LPCWSTR lpszString);
	BOOL PathGetDlgItemPathW(int nID, UString& rString);
	void MoveCenter();
	int DoModal();
	BOOL CreateModal();
	HWND m_hWnd;
	CDialog();
	virtual ~CDialog();

protected:
	BOOL m_bLoopExit;
	int m_nTemplateID;
	HWND m_hWndParent;
	void Loop();
	virtual BOOL DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	static BOOL DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
};

class CProgressDialog : public CDialog
{
public:
	static BOOL SetOwnerWindow(HWND hWnd);
	static BOOL SetOwnerWindowEx(HWND hWnd, LPARCHIVERPROC lpArcProc);
	static BOOL SetOwnerWindowEx64(HWND hWnd, LPARCHIVERPROC lpArcProc, DWORD dwStructSize);
	static BOOL ClearOwnerWindow();
	static BOOL KillOwnerWindowEx(HWND hWnd);
	static BOOL KillOwnerWindowEx64(HWND hWnd);

public:
	void SetArchiveFile(LPCWSTR lpFileName);
	void SetWorkFile(LPCWSTR lpSourceFileName);
	void SetCompleted(UINT64 nSize);
	void SetTotal(UINT64 nSize);
	void SendExtractingInfo(int nMode);
	UString GetDestFileName();
	
	void SetProgressMode(char cMode) { m_cMode = cMode; }
	void SetShowDialog(BOOL bShow) { m_bShow = bShow; }
	HWND GetBecomeParentWindow() { return m_bShow ? m_hWnd : m_hWndParent; }
	UINT64 GetTotalSize() { return m_nTotalSize; }
	void SetArchiveInfo(IInArchive *archive, const UString &directoryPath, NExtract::NPathMode::EEnum pathMode, const UStringVector &removePathParts)
	{
		m_iaHandler = archive;
		m_directoryPath = directoryPath;
		m_pathMode = pathMode;
		m_removePathParts = removePathParts;
	}
	CProgressDialog(HWND hParentWnd);

protected:
	CMyComPtr<IInArchive> m_iaHandler;
	UString m_directoryPath;
	UString m_strSrcFileName;
	NExtract::NPathMode::EEnum m_pathMode;
	UStringVector m_removePathParts;
	EXTRACTINGINFOEX64 m_eis64;
	UINT64 m_nTotalSize;
	char m_cMode;
	BOOL m_bShow;
	BOOL OnInitDialog();
	UInt32 m_nIndex; 
	virtual BOOL DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
};

class CPasswordDialog : public CDialog
{
public:
	UString GetPassword() { return m_strPassword; }
	CPasswordDialog(BOOL bMode);

protected:
	UString m_strPassword;
	BOOL m_bMode;
	virtual BOOL DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
};

class CConfirmationDialog : public CDialog
{
public:
	void SetFileInfo(LPCWSTR lpNewName, UINT64 nNewSize, const FILETIME &ftNewWrite, LPCWSTR lpOldName, UINT64 nOldSize, const FILETIME &ftOldWrite);
	CConfirmationDialog();

protected:
	UString m_strNewName;
	UString m_strOldName;
	UINT64 m_nNewSize;
	UINT64 m_nOldSize;
	FILETIME m_ftNewWrite;
	FILETIME m_ftOldWrite;
	virtual BOOL DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
};

class CConfigDialog : public CDialog
{
public:
	CConfigDialog(HWND hParentWnd);

protected:
	virtual BOOL DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
};

class CSfxDialog : public CDialog
{
public:
	CSfxDialog(HWND hParentWnd);

protected:
	virtual BOOL DialogProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
};

#endif // !defined(AFX_DIALOG_H__B58B4FBD_56DB_4DEF_BF29_A19185CDB778__INCLUDED_)
